<?php

namespace HCM\FPA\Calculos\Apolo;

require_once __DIR__.'/bootstrapConsumer.php';
error_reporting(E_ERROR | E_PARSE);
ini_set("memory_limit","2048M");

use Teknisa\Model\Gestaopessoas\Repositories\FpaCalculoconsumer;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\HCMParameters;
use HCM\FPA\Entity\FpatipocalculoEntity;
use HCM\Util\Mail\Mail;
use HCM\FPA\Calculos\Apolo\PercorreCalculoConsumer;
use Zeedhi\Framework\Session\Session;
use Teknisa\Libs\Util\SMTP;

class CalculoConsumer extends \Zeedhi\Queue\Consumer {

    const QUEUE_NAME_CALCULO = "hcm_calculo_";

	protected static $queueName = '/queue/';
    public $fpaCalculoConsumer;
    private $nrcalculoconsumer;
    private $dsemailoper;
    private $cdoperador;
    private $dtmescompetencia;
    private $nrorg;
    private $tp_processamento;
    private $tipo_calculo;
    private $nrFormulario;
    private $pid;
    private $corpoEmail;

    public function setQueueName($queueName, $pid) {
        self::$queueName .= $queueName;
        $this->pid = $pid;
    }
    
	/**
     * @param string $message
     * @return void
     */
    public function consume($message) {        
        // Tempo de execucao deve ser ilimitado.
        set_time_limit(0);
        
    	try {
            
            $session = new Session();
            $this->hcmParameters = new HCMParameters($session, FPA::getTempDirectory(), null, null);
            
            echo " Iniciando Processo"."<br>";
            echo 'Pid = '.$this->pid."<br>";
            
            $consumerParams = json_decode($message, true);
            $calculoParams  = $consumerParams['CALCULO_PARAMS'][0];
            
            $this->setParameters($calculoParams);
            
            $calcConsumer = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_CALCULOCONSUMER);
            // retorna registro do calculoconsumer da fila e seta a data hora de inicio
            $this->fpaCalculoConsumer = $calcConsumer->findOneBy(array('nrcalculoconsumer' => $this->nrcalculoconsumer, 'nrorg' => $this->nrorg));
            
            if ($this->fpaCalculoConsumer->getIdsituacao() == FpaCalculoconsumer::IDSITUACAO_PENDENTE)
                $this->fpaCalculoConsumer->setIdsituacao(FpaCalculoconsumer::IDSITUACAO_ANDAMENTO);
            if (is_null($this->fpaCalculoConsumer->getDthrinicio()))
                $this->fpaCalculoConsumer->setDthrinicio(DateUtil::getDataAtual());
    
            // Define parametros do operador.
            $this->showAmbiente();
            
            if($this->tipo_calculo === FpatipocalculoEntity::CALC_CONTABILIZACAO){
                $prepara_contabiliza = new PercorreCalculoConsumer(\Setforms2\Shared\Registry::getEntityManager(), $this->hcmParameters, $this->dataSet);
                $this->corpoEmail[] = $prepara_contabiliza->percorreContabilizacaoConsumer($calculoParams["VINCULOS"], $this->fpaCalculoConsumer);
                $operacao = 'Contabilização ';
                $resultado = null;
            }else{
                // inicia processo de calculo
                $percorreCalculo = new PercorreCalculoConsumer(\Setforms2\Shared\Registry::getEntityManager(), $this->hcmParameters, $this->dataSet);
                $resultado = $percorreCalculo->percorreCalculoConsumer($calculoParams["VINCULOS"], $this->fpaCalculoConsumer);
                $operacao = 'Cálculo ';
            }
            
            $calcConsumer->updateDspidprocesso($this->nrorg, $this->nrcalculoconsumer, $this->pid);
            $calculoConsumer = $calcConsumer->retornaCalculoConsumer($this->nrcalculoconsumer, $this->nrorg);
            //Envia email para o operador informando o término do calculo.
            
            if($calculoConsumer[0]['NRTOTPROCESSVINC'] === $calculoConsumer[0]['NRTOTVINCULOS']) {
                $this->notificaCalculo($resultado, $operacao);
                //retorna o pid para ser encerrado o consumidor
                $pid = explode(',', $calculoConsumer[0]['DSPIDPROCESSO']);
                return array(true, $this->pid, array_unique($pid));
            }
        } catch (\Exception $e) {
            echo "Erro: ".$e->getMessage();
            die();
        }
    }
    
    public function notificaCalculo($resultado, $operacao){
        $cdoperador = FPA::getCdOperador();
        $operador = self::retornaOperadorLogado($cdoperador);

        $emailOperadorLogado = $operador->getDsemailoper();
        $nomeOperadorLogado = $operador->getNmoperador();
        
        $ArrayMensagens = array();
        $msgCalculo = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_MSGCALCULO)->findBy(
            array('nrcalculofolha' => $resultado['CALCULO'], 'nrorg' => $this->nrorg, 'dsorigmsg' => 'ERROSCALCULO'), array('nrvinculom' => 'ASC'));
        
        \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_MSGCALCULO)->limpaMsgCalculo($resultado['CALCULO'], $this->nrorg, 'ERROSCALCULO');
            
        if(count($msgCalculo) > 0) {
            foreach ($msgCalculo as $msgCalc) {
                //Alteração feita por Luan Victor 01/09/2022
                //Modificado para que seja feita a divisão correta das mensagens de ERRO e as de ALERTA ao enviar um email de notificação.
                $ArrayMensagensErro = [];
                $ArrayMensagensAlerta = [];
                $vinculo = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::GPE_VINCULOM)->findOneBy(array('nrvinculom' => $msgCalc->getNrvinculom(),'nrorg' => $this->nrorg));
                
                
                if($msgCalc->getIdtipomsg() == "A"){
                    if(empty($ArrayMensagensAlerta[$msgCalc->getNrvinculom()][0])){
                        $ArrayMensagensAlerta[$msgCalc->getNrvinculom()][0] = $msgCalc->getNrvinculom().' - '.$vinculo->getNmvinculom()."<br>";
                    }
                    $ArrayMensagensAlerta[$msgCalc->getNrvinculom()][1] .= $msgCalc->getDescricao()."<br>";
                    
                } else if($msgCalc->getIdtipomsg() == "E") {
                    if(empty($ArrayMensagensErro[$msgCalc->getNrvinculom()][0])){
                        $ArrayMensagensErro[$msgCalc->getNrvinculom()][0] = $msgCalc->getNrvinculom().' - '.$vinculo->getNmvinculom()."<br>";
                    }
                    $ArrayMensagensErro[$msgCalc->getNrvinculom()][1] .= $msgCalc->getDescricao()."<br>";
                    
                }
            }
        }
        $calcFolha = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::FPA_CALCULOFOLHA)->getCalculoFolhaAndTpCalc($this->nrorg, $resultado['CALCULO']);

        $assunto  = $calcFolha[0]['NMTIPOCALCULO'].' - '.$resultado['CALCULO'].' - '.$calcFolha[0]['NROCORRECAL'].' - '.substr($calcFolha[0]['DTOCORRENCIA'],0,10);
        $mensagensAlerta = '';
        $mensagensErro = '';
        foreach($ArrayMensagensAlerta as $mens){
            $mensagensAlerta .= implode('',$mens)."<br>";
        }
        
        foreach($ArrayMensagensErro as $mens){
            $mensagensErro .= implode('',$mens)."<br>";
        }
        
        $parcial = '';
        if($this->tp_processamento == FPA::PROC_APOLO_GRAVAR_PARCIAL){
            $parcial = 'Parcial ';
        }
        $corpo_msg = $nomeOperadorLogado.','."<br>"."<br>".$operacao.$parcial."Finalizado "."<br>"."<br>";
        
        
        //Alteração feita por Luan Victor 01/09/2022
        //Adiciona as mensagens conforme tipo de msg
        if($mensagensErro){
            $corpo_msg .= "Segue as mensagens de Erro:"."<br>"."<br>".$mensagensErro."<br>"."<br>";
        }
        
        if($mensagensAlerta){
            $corpo_msg .= "Mensagens de alerta não impedem o calculo!"."<br>"."<br>";
            $corpo_msg .= "Segue as mensagens de Alerta:"."<br>"."<br>".$mensagensAlerta;
        }
        
        foreach($this->corpoEmail as $mens){
            foreach($mens as $mensagem){
                $mensagemConta .= $mensagem."<br>";
            }
        }

        $corpo_msg .= $mensagemConta;

        $nome_destinatario  = $nomeOperadorLogado;
        
        $mail = $this->hcmParameters->returnParamsSmtp(true);
 
        if(!$mail){
            return;
        }
        
        try {
            
            $mail->newEmail($emailOperadorLogado,  //De/From
                $corpo_msg,                     //texto
                $assunto,                       // assunto    
                $nomeOperadorLogado,            //nome operador
                $nomeOperadorLogado,            //nome from
                $emailOperadorLogado           //from
                );
        }catch (Exception $e) {
            $contFail++;
        }
    }

    public function retornaOperadorLogado($cdoperador){
        $operador = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::OPERADOR)->findOneBy(array('cdoperador' => $cdoperador));
        return $operador;
    }

    private function setParameters($consumerParams) {
        
        $this->nrcalculoconsumer = $consumerParams["NRCALCULOCONSUMER"]; 
        $this->dataSet           = $consumerParams["DATASET"];
        $this->dsemailoper       = $consumerParams["DSEMAILOPER"];
        $this->cdoperador        = $consumerParams["CDOPERADOR"];
        $this->dtmescompetencia  = $consumerParams["DTMESCOMPETENCIA"];
        $this->nrorg             = $consumerParams["NRORG"];
        $this->tp_processamento  = $consumerParams["DATASET"]["TP_PROCESSAMENTO"];
        $this->tipo_calculo      = $consumerParams["DATASET"]["TP_CALCULO"];
        
        foreach ($consumerParams["PARAMSHCM"] as $key => $value) {
            $this->hcmParameters->set($key, $value);
        }
    }

    private function showAmbiente() {
        $nrOcorrenciaCalc   = $this->hcmParameters->getNrOcorrenciaCalculo();
        $nrTpModalidadeCalc = $this->hcmParameters->getTipoModalidadeCalculo();
        $dataExecucao       = DateUtil::getDataAtual();

        $ambiente = "Org.: $this->nrorg\nCompetencia: $this->dtmescompetencia\nTipo Calculo: $this->tipo_calculo\nProcesso: $this->tp_processamento\n
        Ocorrencia: $nrOcorrenciaCalc\nModalidade Calculo: $nrTpModalidadeCalc\n
        Operador: $this->cdoperador\nData Execucao: $dataExecucao\nNr. Calculo Consumer: $this->nrcalculoconsumer";
        
        echo $ambiente."<br>";
        echo "<br>"."---------------"."<br>";

        // set a propriedade DSCALCULOPARAMS do registro em calculoconsumer
        $this->fpaCalculoConsumer->setDscalculoparams(str_replace("\n", " - ", $ambiente));
    }
}

if (!isset($argv[1])) {
    die('Parametro de organizacao nao informado.');
}

$nrorg = $argv[1];
$pid = getmypid();

$paramsApolo = FPA::getParamsApolo();
        
$url = $paramsApolo['URL'];
$port = $paramsApolo['PORT'];
$user = $paramsApolo['USER'];
$password = $paramsApolo['PASSWORD'];
$broke = $paramsApolo['BROKE'];

$connection = new \Zeedhi\Queue\Connection($url, $port, $user, $password, $broke);

$consumer = new CalculoConsumer($connection);
$consumer->setQueueName(CalculoConsumer::QUEUE_NAME_CALCULO.$nrorg, $pid);
$consumer->run();