<?php

namespace HCM\Geral\Entity;

use HCM\Util\Repositories;
use HCM\Util\MsgCalculo;
use HCM\Util\Util;
use HCM\Util\FPA;
use HCM\Util\TkEntity;

class GpeescalatrabmEntity extends TkEntity
{
    public function __construct($entityManager, $hcmParameters) {
        
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        parent::__construct(null,$entityManager);
    }
    
    private function _inicializaLista($nrOrg){
        $tmp = $this->retornaEscalas($nrOrg);
        foreach ($tmp as $tmp_escala) {
            $this->addItem($tmp_escala, $tmp_escala->getNrescalatrabm());
        }
    }

    public function retornaEscala($nr_escala, $nrOrg){
        $itens = $this->getItems();
        if (empty($itens) === true) {
            $this->_inicializaLista($nrOrg);
            $itens = $this->getItems();
        }
        return $itens[$nr_escala];
    }

    public function retornaEscalas($nrOrg){
        $escalas = array();
        try{
            $escalas = $this->entityManager->getRepository(Repositories::GPE_ESCALATRABM)->getEscalatrabm($nrOrg);
        } catch (Exception $e){
            echo $e->getMessage().'<br />';
        }
        foreach ($escalas as &$escala) {
            $historico = $this->entityManager->getRepository(Repositories::GPE_ESCALATRABH)->findBy(
                array("nrorg" => $nrOrg,"nrescalatrabm" => $escala->getNrescalatrabm()),array("dtmescompetenc" => 'DESC'));
            $escala->historico = $historico[0];
        }

        return $escalas;
    }
    
    public function retornaEscalaNrEscala($nr_escala, $nrOrg){
        $escala = $this->entityManager->getRepository(Repositories::GPE_ESCALATRABM)->retornaEscalaTrab($nr_escala, $nrOrg);
        $escalah = $this->entityManager->getRepository(Repositories::GPE_ESCALATRABH)->retornaUltimoHistorico($nr_escala, $nrOrg);
        $escala->historico = $escalah;
        return $escala;
    }
    
    public function novoMestre($nrescalatrabm, $nrorgTrab){
        try{
            $now = new TkDateTime();
            $now = $now->toString(TkDateTime::FORMAT_DATE);

            $this->setNrescalatrabm($nrescalatrabm);
            $this->setDtinivigencia($now);
            $this->setNrorg($nrorgTrab);
            $this->setDtinclusao($now);

            $this->persist();
            return true;
        }
        catch (Exception $e){
            return false;
        }
    }

    public function destroiMestre($nrescalatrabm, $nrorgTrab){
        try{
            $escalatrab = Gpeescalatrabm::retornaEscalaTrab($nrescalatrabm, $nrorgTrab);
            if (is_object($escalatrab) === true) {
                $this->addItem($escalatrab, $nrescalatrabm);
                $this->removeItem($escalatrab);
                $this->persist();
                return true;
            } else {
                return false;
            }
        }
        catch (Exception $e){
            return false;
        }
    }
    
}