<?php
namespace HCM\PTO\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class ApuracaoFrequenciaRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }
    

    public function getVinculosPorSelecaoNRescindidos($criterio, $inicio, $fim, $dtCompetencia, $nrTipoVinculo, $nrOrgPadrao, $nrOrg, $apuraRescindidos, $fimPeriodo, $iniPeriodo) {
        $whereRescindidos = "VCM.DTRESCISAOVINC IS NULL"; 
        if ($apuraRescindidos == 'S') { 
          $whereRescindidos .= " OR VCM.DTRESCISAOVINC >= TO_DATE('$iniPeriodo', 'DD/MM/YYYY')"; 
        }        

        if($criterio == 'NMVINCULOM'  || $criterio == 'DTADMISSAOVINC' ||
            $criterio == 'CDMATRICULA' || $criterio == 'NRESTRUTLEGAL') {
            $query = "SELECT VCM.NRVINCULOM,
                           VCM.NMVINCULOM
                      FROM GPE_TIPOVINCULOM TVM, GPE_VINCULOM VCM
                INNER JOIN GPE_VINCULOH VCH
                        ON (VCH.NRVINCULOM = VCM.NRVINCULOM
                            AND  VCH.NRORG = VCM.NRORG)
                     WHERE ((($criterio BETWEEN '$inicio' AND '$fim') AND '$criterio' <> 'NRESTRUTLEGAL')
                        OR (TO_CHAR(VCH.NRESTRUTLEGAL) = '$inicio'
                            AND ((TO_CHAR(VCH.NRESTRUTGEREN) = '$fim') OR ('$fim' IS NULL))))
                       AND VCH.DTMESCOMPETENC IN (
                                                  SELECT MAX(VIH.DTMESCOMPETENC)
                                                    FROM GPE_VINCULOH VIH
                                                   WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                     AND VIH.NRORG = VCM.NRORG
                                                     AND VIH.DTMESCOMPETENC <= TO_DATE('$dtCompetencia', 'DD/MM/YYYY')
                                                 )
                       AND ($whereRescindidos)
                       AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                       AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                       AND VCM.NRORG  = $nrOrg
                       AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)
                     ORDER BY VCM.NMVINCULOM";
        } else {
            $query = "SELECT VCM.NRVINCULOM,
                           VCM.NMVINCULOM
                      FROM GPE_TIPOVINCULOM TVM, GPE_VINCULOM VCM
                INNER JOIN GPE_VINCULOH VCH
                        ON (VCH.NRVINCULOM = VCM.NRVINCULOM
                            AND  VCH.NRORG = VCM.NRORG)
                     WHERE VCH.DTMESCOMPETENC IN (
                                                  SELECT MAX(VIH.DTMESCOMPETENC)
                                                    FROM GPE_VINCULOH VIH
                                                   WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                     AND VIH.NRORG = VCM.NRORG
                                                     AND VIH.DTMESCOMPETENC <= TO_DATE('$dtCompetencia', 'DD/MM/YYYY')
                                                 )
                       AND ($whereRescindidos)
                       AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                       AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                       AND VCM.NRORG = $nrOrg
                       AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)
                     ORDER BY VCM.NMVINCULOM";
        }
        $result = $this->connection->fetchAll($query);
        return (count($result) > 0) ? $result : false;
    }

    public function getResumoSituFreqVinculo($nrOrg, $nrVinculom, $nrPeriododApuracao) {
        $query = "SELECT * 
                    FROM PTO_RESUMOSITUFREQ 
                   WHERE NRORG = $nrOrg
                     AND NRVINCULOM = $nrVinculom
                     AND NRPERIODOAPURACAO = $nrPeriododApuracao";
        
        $result = $this->connection->fetchAll($query);
        return (count($result) > 0) ? $result : false;
    }

    public function verificaControleJornada($nrOrg, $nrvinculom, $fimPeriodo) {
        $query = "SELECT IDNAOCONTROLAJORNADA
                    FROM GPE_ESCALATRABH ESCALATRABH

                    JOIN GPE_ALTEESCALA ALTEESCALA
                      ON ESCALATRABH.NRORG          = ALTEESCALA.NRORG
                     AND ESCALATRABH.NRESCALATRABM  = ALTEESCALA.NRESCALATRABM
                     AND ALTEESCALA.NRVINCULOM      = $nrvinculom
                     AND ESCALATRABH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                             FROM GPE_ESCALATRABH
                                                            WHERE ESCALATRABH.NRORG               = GPE_ESCALATRABH.NRORG
                                                              AND ESCALATRABH.NRESCALATRABM       = GPE_ESCALATRABH.NRESCALATRABM
                                                              AND GPE_ESCALATRABH.DTMESCOMPETENC <= '$fimPeriodo')

                   WHERE ALTEESCALA.DTINIESCALA = (SELECT MAX(DTINIESCALA)
                                                     FROM GPE_ALTEESCALA
                                                    WHERE GPE_ALTEESCALA.NRORG      = ALTEESCALA.NRORG
                                                      AND GPE_ALTEESCALA.NRVINCULOM = ALTEESCALA.NRVINCULOM
                                                      AND GPE_ALTEESCALA.DTINIESCALA <= '$fimPeriodo')
                    AND ALTEESCALA.NRORG = $nrOrg";
        $result = $this->connection->fetchAll($query);
        return empty($result) ? $result : $result[0]['IDNAOCONTROLAJORNADA'];
    }

    public function deleteMarcacoes($nrorg, $nrvinculom, $nrperiodoapuracao) {
      $query = "DELETE FROM GPE_MARCACAOPONTO
                      WHERE NRORG = $nrorg
                        AND NRMARCACAOPONTO IN (SELECT NRMARCACAOPONTO
                                                    FROM GPE_MARCACAOPONTO
                                                    JOIN PTO_PERIODOAPURACAO
                                                      ON PTO_PERIODOAPURACAO.NRORG              = GPE_MARCACAOPONTO.NRORG
                                                     AND TRUNC(GPE_MARCACAOPONTO.DTHRAJUSTADA) >= TRUNC(PTO_PERIODOAPURACAO.DTINICIALAPURACAO)
                                                     AND TRUNC(GPE_MARCACAOPONTO.DTHRAJUSTADA) <= TRUNC(PTO_PERIODOAPURACAO.DTFINALAPURACAO)
                      JOIN GPE_PARAMORG
                        ON GPE_PARAMORG.NRORG                = GPE_MARCACAOPONTO.NRORG
                      AND (GPE_PARAMORG.NRCOLETORMARCGERSIST   = GPE_MARCACAOPONTO.NRCOLETOR OR
                           GPE_PARAMORG.NRCOLETORMARCPROJETADA = GPE_MARCACAOPONTO.NRCOLETOR OR
                           GPE_PARAMORG.NRCOLETORMARCVIRADIA   = GPE_MARCACAOPONTO.NRCOLETOR OR
                           GPE_PARAMORG.NRCOLETORMARCAUTOM     = GPE_MARCACAOPONTO.NRCOLETOR)
                     WHERE GPE_MARCACAOPONTO.NRORG             = $nrorg
                       AND GPE_MARCACAOPONTO.NRVINCULOM        = $nrvinculom
                       AND NRPERIODOAPURACAO                   = $nrperiodoapuracao)";

      $this->connection->exec($query);
    }

    public function deleteIntervalos($nrorg, $nrvinculom, $nrperiodoapuracao) {
      $query = "DELETE FROM PTO_INTERVALOSMARCACAO
                      WHERE NRORG = $nrorg
                        AND NRINTERVALOSMARCACAO IN (SELECT NRINTERVALOSMARCACAO
                       FROM PTO_INTERVALOSMARCACAO
                       JOIN GPE_MARCACAOPONTO MARCACAOINI
                         ON MARCACAOINI.NRORG           = PTO_INTERVALOSMARCACAO.NRORG
                        AND MARCACAOINI.NRMARCACAOPONTO = PTO_INTERVALOSMARCACAO.NRMARCACAOPONTOINI
                       JOIN GPE_MARCACAOPONTO MARCACAOFIM
                         ON MARCACAOFIM.NRORG           = PTO_INTERVALOSMARCACAO.NRORG
                        AND MARCACAOFIM.NRMARCACAOPONTO = PTO_INTERVALOSMARCACAO.NRMARCACAOPONTOFIM
                       JOIN PTO_PERIODOAPURACAO
                         ON PTO_PERIODOAPURACAO.NRORG = PTO_INTERVALOSMARCACAO.NRORG
                        AND TRUNC(MARCACAOINI.DTHRAJUSTADA) >= TRUNC(PTO_PERIODOAPURACAO.DTINICIALAPURACAO)
                        AND TRUNC(MARCACAOINI.DTHRAJUSTADA) <= TRUNC(PTO_PERIODOAPURACAO.DTFINALAPURACAO)
                        AND TRUNC(MARCACAOFIM.DTHRAJUSTADA) >= TRUNC(PTO_PERIODOAPURACAO.DTINICIALAPURACAO)
                        AND TRUNC(MARCACAOFIM.DTHRAJUSTADA) <= TRUNC(PTO_PERIODOAPURACAO.DTFINALAPURACAO)
                      WHERE PTO_INTERVALOSMARCACAO.NRORG = $nrorg
                        AND MARCACAOINI.NRVINCULOM       = $nrvinculom
                        AND NRPERIODOAPURACAO            = $nrperiodoapuracao)";

      $this->connection->exec($query);
    }

    public function deleteResumos($nrorg, $nrvinculom, $nrperiodoapuracao) {
      $query = "DELETE FROM PTO_RESUMOSITUFREQ
                      WHERE NRORG             = $nrorg
                        AND NRVINCULOM        = $nrvinculom
                        AND NRPERIODOAPURACAO = $nrperiodoapuracao";
        
      $this->connection->exec($query);
    }

    public function updateMarcacoesAlteradas($nrorg, $nrvinculom, $nrperiodoapuracao) {
      $query = $this->entityManager->getConnection()->prepare("
                  UPDATE GPE_MARCACAOPONTO
                   SET IDMARCDESPREZADA  = 'N',
                       IDENQUADRAHORARIO = 'N'
                 WHERE NRORG = $nrorg
                    AND NRMARCACAOPONTO IN (SELECT NRMARCACAOPONTO
                                             FROM GPE_MARCACAOPONTO
                                             JOIN PTO_PERIODOAPURACAO
                                               ON PTO_PERIODOAPURACAO.NRORG       = GPE_MARCACAOPONTO.NRORG
                                              AND TRUNC(GPE_MARCACAOPONTO.DTHRAJUSTADA) >= TRUNC(PTO_PERIODOAPURACAO.DTINICIALAPURACAO)
                                              AND TRUNC(GPE_MARCACAOPONTO.DTHRAJUSTADA) <= TRUNC(PTO_PERIODOAPURACAO.DTFINALAPURACAO)
                                            WHERE GPE_MARCACAOPONTO.NRORG             = $nrorg
                                              AND GPE_MARCACAOPONTO.NRVINCULOM        = $nrvinculom
                                              AND NRPERIODOAPURACAO                   = $nrperiodoapuracao)");
        
      return $query->execute();
    }

    public function updateNovoCodigoResumos($nrorg) {
        checkNovoCodigoIfExists('PTO_RESUMOSITUFREQ', false);
        $query = $this->entityManager->getConnection()->prepare("
                  UPDATE NOVOCODIGO
                   SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRRESUMOSITUFREQ) + 1,'20','0')
                                         FROM PTO_RESUMOSITUFREQ
                                        WHERE NRORG  = $nrorg
                                        )
                 WHERE NRORG      = $nrorg
                   AND CDCONTADOR = 'PTO_RESUMOSITUFREQ'");
        
        return $query->execute();
    }

    public function updateNovoCodigoMarcacoes($nrorg) {
        checkNovoCodigoIfExists('GPE_MARCACAOPONTO', false);
        $query = $this->entityManager->getConnection()->prepare("
                  UPDATE NOVOCODIGO
                   SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRMARCACAOPONTO) + 1,'20','0')
                                         FROM GPE_MARCACAOPONTO
                                        WHERE NRORG  = $nrorg
                                        )
                 WHERE NRORG      = $nrorg
                   AND CDCONTADOR = 'GPE_MARCACAOPONTO'");
        
      return $query->execute();
    }

    public function updateNovoCodigoIntervalos($nrorg) {
        checkNovoCodigoIfExists('PTO_INTERVALOSMARCACAO', false);
        $query = $this->entityManager->getConnection()->prepare("
                UPDATE NOVOCODIGO
                   SET NRSEQUENCIAL = (SELECT LPAD(MAX(NRINTERVALOSMARCACAO) + 1,'20','0')
                                         FROM PTO_INTERVALOSMARCACAO
                                        WHERE NRORG  = $nrorg
                                        )
                WHERE NRORG      = $nrorg
                    AND CDCONTADOR = 'PTO_INTERVALOSMARCACAO'");
        
      return $query->execute();
    }
   
    public function getPeriodoSimulacao ($params){
        $query = "SELECT TO_CHAR(DTDATA ,'DD/MM/YYYY') AS DATA,
                         TO_CHAR(DTDATA, 'DY', 'NLS_DATE_LANGUAGE = PORTUGUESE') AS DIA,
                         GPE_VINCULOM.NRVINCULOM,
                         GPE_VINCULOM.NMVINCULOM
                    FROM DATA
                    JOIN GPE_VINCULOM ON 1 = 1
                    JOIN GPE_VINCULOH ON GPE_VINCULOH.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                                     AND GPE_VINCULOH.NRORG = GPE_VINCULOM.NRORG
                                     AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(VH.DTMESCOMPETENC)
                                                                          FROM GPE_VINCULOH VH
                                                                         WHERE VH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM
                                                                           AND VH.NRORG = GPE_VINCULOH.NRORG
                                                                           AND VH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                   WHERE DTDATA BETWEEN :P_DTINICIAL AND :P_DTFINAL
                     AND (INSTR(','||:P_NRVINCULOM||',', ','||GPE_VINCULOM.NRVINCULOM||',') > 0 OR :P_NRVINCULOM IS NULL)
                     AND (INSTR(','||:P_NRESTRUTLEGAL||',', ','||GPE_VINCULOH.NRESTRUTLEGAL||',') > 0 OR :P_NRESTRUTLEGAL IS NULL)
                     AND (INSTR(','||:P_NRESTRUTGEREN||',', ','||GPE_VINCULOH.NRESTRUTGEREN||',') > 0 OR :P_NRESTRUTGEREN IS NULL)
                     AND GPE_VINCULOM.NRORG = :P_NRORG
                     AND (GPE_VINCULOM.DTRESCISAOVINC IS NULL OR GPE_VINCULOM.DTRESCISAOVINC >= :P_DTMESCOMPETENC)
                     AND GPE_VINCULOM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)";
        $params =  array('P_DTMESCOMPETENC' => $params['P_DTMESCOMPETENC'],
                         'P_DTINICIAL'      => $params['P_DTINICIAL'],
                         'P_DTFINAL'        => $params['P_DTFINAL'], 
                         'P_NRVINCULOM'     => array_key_exists('P_NRVINCULOM', $params) ? $params['P_NRVINCULOM'] : null,
                         'P_NRESTRUTLEGAL'  => array_key_exists('P_NRESTRUTLEGAL', $params) ? $params['P_NRESTRUTLEGAL'] : null,
                         'P_NRESTRUTGEREN'  => array_key_exists('P_NRESTRUTGEREN', $params) ? $params['P_NRESTRUTGEREN'] : null,
                         'P_NRORG'          => $params['P_NRORG']);
        $result = $this->connection->fetchAll($query, $params);
        return $result;
    }

    public function getVinculosSimulacao ($criterio, $inicio, $fim, $date, $nrTipoVinculo, $nrOrgPadrao, $nrorg){
        if($criterio == 'NMVINCULOM' || $criterio == 'DTADMISSAOVINC' ||
            $criterio == 'CDMATRICULA' || $criterio == 'NRESTRUTLEGAL'){
            $query = "SELECT VCM.NRVINCULOM,
                           VCM.CDMATRICULA,
                           VCM.NMVINCULOM,
                           VCM.NRTIPOVINCULOM,
                           TVH.NMTIPOVINCULOH,
                           VCM.NRVINCULOEMPREG,
                           VCE.NMABREV,
                           TO_CHAR(VCM.DTADMISSAOVINC,'DD/MM/YYYY') AS DTADMISSAOVINC,
                           TO_CHAR(VCM.DTAVISOPREVIO,'DD/MM/YYYY') AS DTAVISOPREVIO,
                           TO_CHAR(VCM.DTRESCISAOVINC,'DD/MM/YYYY') AS DTRESCISAOVINC,
                           VCM.NRORG
                      FROM GPE_VINCULOM VCM
                INNER JOIN GPE_VINCULOH VCH
                        ON (VCH.NRVINCULOM = VCM.NRVINCULOM
                            AND  VCH.NRORG = VCM.NRORG)
                INNER JOIN GPE_TIPOVINCULOM TVM
                        ON (TVM.NRTIPOVINCULOM = VCM.NRTIPOVINCULOM)
                INNER JOIN GPE_TIPOVINCULOH TVH
                        ON (TVH.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                            AND TVH.NRORG = TVM.NRORG)
                INNER JOIN GPE_VINCULOEMPREG VCE
                        ON (VCE.NRVINCULOEMPREG = VCM.NRVINCULOEMPREG)
                     WHERE VCM.NRORG = $nrorg
                        AND (($criterio BETWEEN '$inicio' AND '$fim')
                        OR (TO_CHAR(VCH.NRESTRUTLEGAL) = '$inicio'
                            AND ((TO_CHAR(VCH.NRESTRUTGEREN) = '$fim') OR ('$fim' IS NULL))))
                       AND VCH.DTMESCOMPETENC IN (
                                                  SELECT MAX(VIH.DTMESCOMPETENC)
                                                    FROM GPE_VINCULOH VIH
                                                   WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                     AND VIH.NRORG = VCM.NRORG
                                                     AND VIH.DTMESCOMPETENC <= TO_DATE('$date', 'DD/MM/YYYY')
                                                 )
                       AND (VCM.DTRESCISAOVINC IS NULL OR VCM.DTRESCISAOVINC > TO_DATE('$date', 'DD/MM/YYYY'))
                       AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                       AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                       AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)
                     ORDER BY VCM.NMVINCULOM";
        }
        else{
            $query = "SELECT VCM.NRVINCULOM,
                           VCM.CDMATRICULA,
                           VCM.NMVINCULOM,
                           VCM.NRTIPOVINCULOM,
                           TVH.NMTIPOVINCULOH,
                           VCM.NRVINCULOEMPREG,
                           VCE.NMABREV,
                           TO_CHAR(VCM.DTADMISSAOVINC,'DD/MM/YYYY') AS DTADMISSAOVINC,
                           TO_CHAR(VCM.DTAVISOPREVIO,'DD/MM/YYYY') AS DTAVISOPREVIO,
                           TO_CHAR(VCM.DTRESCISAOVINC,'DD/MM/YYYY') AS DTRESCISAOVINC,
                           VCM.NRORG
                      FROM GPE_VINCULOM VCM
                INNER JOIN GPE_VINCULOH VCH
                        ON (VCH.NRVINCULOM = VCM.NRVINCULOM
                            AND  VCH.NRORG = VCM.NRORG)
                INNER JOIN GPE_TIPOVINCULOM TVM
                        ON (TVM.NRTIPOVINCULOM = VCM.NRTIPOVINCULOM)
                INNER JOIN GPE_TIPOVINCULOH TVH
                        ON (TVH.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                            AND TVH.NRORG = TVM.NRORG)
                INNER JOIN GPE_VINCULOEMPREG VCE
                        ON (VCE.NRVINCULOEMPREG = VCM.NRVINCULOEMPREG)
                     WHERE VCH.DTMESCOMPETENC IN (
                                                  SELECT MAX(VIH.DTMESCOMPETENC)
                                                    FROM GPE_VINCULOH VIH
                                                   WHERE VIH.NRVINCULOM  = VCM.NRVINCULOM
                                                     AND VIH.NRORG = VCM.NRORG
                                                     AND VIH.DTMESCOMPETENC <= TO_DATE('$date', 'DD/MM/YYYY')
                                                 )
                       AND (VCM.DTRESCISAOVINC IS NULL OR VCM.DTRESCISAOVINC > TO_DATE('$date', 'DD/MM/YYYY'))
                       AND VCM.NRTIPOVINCULOM = TVM.NRTIPOVINCULOM
                       AND VCM.NRTIPOVINCULOM = $nrTipoVinculo
                       AND (TVM.NRORG = VCM.NRORG OR TVM.NRORG = $nrOrgPadrao)
                     ORDER BY VCM.NMVINCULOM";
        }
        $result = $this->connection->fetchAll($query);
        return $result;
    }
}