CREATE OR REPLACE PROCEDURE NOTAFISCAL_NFE_MANAUS(
   P_NRLISTA     IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CDEMPRESA   IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_DTINICIAL   IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_DTFINAL     IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_NRSEQARQMAG IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_LIVROMAG    IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CDINSCMUNI  IN NOTAFISCAL.CDINSCMUNI%TYPE,
   P_VERSAO      IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_TPRPS       IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_SIMPLES     IN NOTAFISCAL.NRLANCTONF%TYPE)
AS
   V_EMPRESA       VARCHAR2(4000);
   V_DADOS         VARCHAR2(4000);
   V_DADOS_9       VARCHAR2(4000);
   V_ISS           VARCHAR2(02);
   V_ISS_NRET      VARCHAR2(02);
   V_COFINS        VARCHAR2(02);
   V_CSLL          VARCHAR2(02);
   V_INSS          VARCHAR2(02);
   V_IRPJ          VARCHAR2(02);
   V_PIS           VARCHAR2(02);
   V_VRRPS         VARCHAR2(01);
   V_CONTADOR      NUMBER;
   V_CONT_REG_2    NUMBER;
   V_VRDEDUCAO     NUMBER;
   V_VRTOTAL       NUMBER;
   V_VRTOTDEDUCAO  NUMBER;
   V_VRTOTISS      NUMBER;
   V_VRTOTISS_NRET NUMBER;
   V_VRTOTCOFINS   NUMBER;
   V_VRTOTCSLL     NUMBER;
   V_VRTOTINSS     NUMBER;
   V_VRTOTIRPJ     NUMBER;
   V_VRTOTPIS      NUMBER;
   V_VRTOTCRED     NUMBER;
   V_VRTOTCRED_2   NUMBER;
BEGIN
   /* sequencial para gerao da nota fiscal paulista */
   V_CONTADOR      := 0000000000;
   V_CONT_REG_2    := 0;
   V_VRDEDUCAO     := 0;
   V_VRTOTAL       := 0;
   V_VRTOTDEDUCAO  := 0;
   V_VRTOTISS      := 0;
   V_VRTOTISS_NRET := 0;
   V_VRTOTCOFINS   := 0;
   V_VRTOTCSLL     := 0;
   V_VRTOTINSS     := 0;
   V_VRTOTIRPJ     := 0;
   V_VRTOTPIS      := 0;
   V_VRTOTCRED     := 0;
   V_VRTOTCRED_2   := 0;

   /* busca o codigo do imposto ISS (Retido)*/
   BEGIN
      SELECT CDIMPOSTOLIVRO
      INTO V_ISS
      FROM TPIMPOSLIVRO T
      WHERE CDLIVROMAG = P_LIVROMAG
        AND SGIMPOSTOLIVRO LIKE 'ISS';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_ISS    := NULL;
   END;

   /* busca o codigo do imposto ISSQN (No retido)*/
   BEGIN
      SELECT CDIMPOSTOLIVRO
      INTO V_ISS_NRET
      FROM TPIMPOSLIVRO T
      WHERE CDLIVROMAG = P_LIVROMAG
        AND SGIMPOSTOLIVRO LIKE 'ISSQN (S)';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_ISS_NRET    := NULL;
   END;

   /* Busca o cdigo do imposto COFINS */
   BEGIN
      SELECT CDIMPOSTOLIVRO
      INTO V_COFINS
      FROM TPIMPOSLIVRO
      WHERE CDLIVROMAG = P_LIVROMAG
        AND SGIMPOSTOLIVRO LIKE 'COFINS';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_COFINS := NULL;
   END;

   /* Busca o cdigo do imposto CSLL */
   BEGIN
      SELECT CDIMPOSTOLIVRO
      INTO V_CSLL
      FROM TPIMPOSLIVRO
      WHERE CDLIVROMAG = P_LIVROMAG
        AND SGIMPOSTOLIVRO LIKE 'CSLL';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CSLL := NULL;
   END;

   /* Busca o cdigo do imposto INSS */
   BEGIN
      SELECT CDIMPOSTOLIVRO
      INTO V_INSS
      FROM TPIMPOSLIVRO
      WHERE CDLIVROMAG = P_LIVROMAG
        AND SGIMPOSTOLIVRO LIKE 'INSS';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_INSS := NULL;
   END;

   /* Busca o cdigo do imposto IRPJ */
   BEGIN
      SELECT CDIMPOSTOLIVRO
      INTO V_IRPJ
      FROM TPIMPOSLIVRO
      WHERE CDLIVROMAG = P_LIVROMAG
        AND SGIMPOSTOLIVRO LIKE 'IRPJ';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IRPJ := NULL;
   END;

   /* Busca o cdigo do imposto PIS */
   BEGIN
      SELECT CDIMPOSTOLIVRO
      INTO V_PIS
      FROM TPIMPOSLIVRO
      WHERE CDLIVROMAG = P_LIVROMAG
        AND SGIMPOSTOLIVRO LIKE 'PIS';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_PIS := NULL;
   END;

   /* Comparao para preenchimento do campo 2 */
   IF(P_TPRPS = 'RPS -') THEN
      V_VRRPS := '0';
   ELSIF(P_TPRPS = 'RPS-M') THEN
      V_VRRPS := '1';
   ELSE
      V_VRRPS := '2';
   END IF;

   /* TIPO 1 */
   V_EMPRESA :=  '1'||
                 P_VERSAO||
                 LPAD(REPLACE(REPLACE(REPLACE(P_CDINSCMUNI,'-',''),'.',''),'/',''),15,'0')||
                 TO_CHAR(P_DTINICIAL, 'yyyymmdd')||
                 TO_CHAR(P_DTFINAL, 'yyyymmdd');

   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (V_CONTADOR, V_EMPRESA, P_NRSEQARQMAG);
   V_CONTADOR := NVL(V_CONTADOR,0)+1;

   /* TIPO 2 */      /* FORNECEDOR ISS RETIDO*/
   FOR C_NOTAS IN (SELECT N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'C' ),0)      AS VRTOTISS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'C' ),0) AS VRTOTISS_NRET,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0)   AS VRTOTCOFINS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0)     AS VRTOTCSLL,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0)     AS VRTOTINSS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0)     AS VRTOTIRPJ,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0)      AS VRTOTPIS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'I' ),0)      AS VRTOTCRED,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'I' ),0) AS VRTOTCRED_2,
                          '2'||
                          V_VRRPS||
                          RPAD(NVL(DECODE(N.IDENTRSAIDOP, 'S', CDSERIE, CDSERIEENTR),' '), 5, ' ')|| /* campo 3 */
                          LPAD(NVL(NRNOTAFISC,'0'), 15, '0')|| /* numero do rps */
                          TO_CHAR(DTEMISSAO, 'yyyymmdd')|| /* data de emissao do rps */
                          DECODE(IDSTATUS, 'C', 'C', 'T')|| /* situacao do rps */
                          RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '0000000000000.00')), '.', ''),'00'),15,'0') AS DSINICIO,

                          '00017051'|| /* codigo do servico prestado na nf */
                          LPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'A' ),2), '00.00')), '.', ''),'0'),5,'0')|| /* valor da aliquota campo 10 */
                          '1'|| /* ISS RETIDO  campo 11 */
                          DECODE(F.IDTPIJURFORN, 'F', '1','2')||
                          LPAD(REPLACE(REPLACE(REPLACE(N.NRINSJURNF,'.',''),'/',''),'-',''),14,'0')|| /* campo 13 */
                          REPLACE(REPLACE(REPLACE(LPAD(NVL(NRINSMUNFORN, '0'), 15,'0'),'/',''),'-',''),'.','')|| /* inscricao municipal do tomador (fornecedor) campo 14 */
                          LPAD(NVL(REPLACE(REPLACE(REPLACE(NRINSESTFORN,'/',''),'.',''),'-',''), '0'), 15,'0')|| /* inscricao estadual do tomador */
                          UPPER(RPAD(NVL(SUBSTR(NMRAZSOCFORN, 1,115), ' '), 115,' '))|| /* campo 16 */
                          LPAD(' ', 3,' ')|| /* tipo de endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSENDEFORN, 1,100), ' '), 100,' '))|| /* DESCRIO DO ENDEREO*/
                          LPAD(' ', 10,' ')|| /* numero do endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSCOMPENDFOR, 1,60), ' '), 60,' '))|| /* CAMPO DE COMPLEMENTO DO ENDEREO */
                          UPPER(RPAD(NVL(SUBSTR(NMBAIRFORN, 1,72), ' '), 72,' '))|| /* BAIRRO DO TOMADOR */
                          UPPER(RPAD(NVL(SUBSTR(M.NMMUNICIPIO,1,50), ' '), 50,' '))|| /* cidade do tomador */
                          RPAD(NVL(E.SGESTADO, ' '), 2,' ')||  /* uf do tomador */
                          LPAD(NVL(SUBSTR(REPLACE(REPLACE(NRCEPFORN,'.',''),'-',''),1,8), '0'), 8,'0')|| /*CEP DO ENDEREO DO TOMADOR*/
                          UPPER(RPAD(NVL(DSEMAILFORN, ' '), 80,' '))|| /* CAMPO DE EMAIL DO TOMADOR */
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  || /* CAMPO 26*/
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  || /* CAMPO 27*/
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  || /* CAMPO 28*/
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  || /* CAMPO 29*/
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) || /* CAMPO 30*/
                          UPPER(RPAD(NVL(SUBSTR(DSPRODEMIS,1,1000), ' '), 100,' ')) AS DSFINAL

                   FROM NOTAFISCAL N, FORNECEDOR F, ENDEFORN E,
                        MUNICIPIO M, LISTA L, EMPRESA EP, IMPOSTO IT,
                        MUNICIPIO MU, ITEMPRODUTO IP, IMPOSTONF IF,
                        INSCRMUNICIP IM, INSCRESTAD IE
                   WHERE IDTPENDEFORN = 'P'
                     AND N.IDORIGDESTNF = 'F'
                     AND L.NRLISTA = P_NRLISTA
                     AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                     AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                     AND N.CDFORNECED = F.CDFORNECED
                     AND N.CDFILIAL = IP.CDFILIAL
                     AND N.NRLANCTONF = IP.NRLANCTONF
                     AND F.CDFORNECED = E.CDFORNECED
                     AND E.CDPAIS = M.CDPAIS
                     AND E.SGESTADO = M.SGESTADO
                     AND E.CDMUNICIPIO = M.CDMUNICIPIO
                     AND EP.CDEMPRESA = N.CDEMPRESA
                     AND EP.CDPAIS = MU.CDPAIS
                     AND EP.SGESTADO = MU.SGESTADO
                     AND EP.CDMUNICIPIO = MU.CDMUNICIPIO
                     AND N.CDEMPRESA = IM.CDEMPRESA
                     AND N.CDINSCMUNI = IM.CDINSCMUNI
                     AND N.CDEMPRESA = IE.CDEMPRESA
                     AND N.CDINSCESTA = IE.CDINSCESTA
                     AND IF.CDIMPOSTO   = V_ISS
                     AND IF.NRLANCTONF  = N.NRLANCTONF
                     AND IF.CDFILIAL    = N.CDFILIAL
                     AND IT.CDIMPOSTO   = V_ISS

                   /* FORNECEDOR ISS NO RETIDO*/
                   UNION ALL
                   SELECT N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'C' ),0)      AS VRTOTISS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'C' ),0) AS VRTOTISS_NET,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0)   AS VRTOTCOFINS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0)     AS VRTOTCSLL,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0)     AS VRTOTINSS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0)     AS VRTOTIRPJ,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0)      AS VRTOTPIS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'I' ),0)      AS VRTOTCRED,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'I' ),0) AS VRTOTCRED_2,
                          '2'||
                          V_VRRPS||
                          RPAD(NVL(DECODE(N.IDENTRSAIDOP, 'S', CDSERIE, CDSERIEENTR),' '), 5, ' ')|| /* campo 3 */
                          LPAD(NVL(NRNOTAFISC,'0'), 15, '0')|| /* numero do rps */
                          TO_CHAR(DTEMISSAO, 'yyyymmdd')|| /* data de emissao do rps */
                          DECODE(IDSTATUS, 'C', 'C', 'T')|| /* situacao do rps */
                          RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '0000000000000.00')), '.', ''),'00'),15,'0') AS DSINICIO,

                          '00017051'|| /* codigo do servico prestado na nf */
                          LPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'A' ),2), '00.00')), '.', ''),'0'),5,'0')|| /* valor da aliquota campo 10 */
                          '0'|| /* ISS NO RETIDO  campo 11 */
                          DECODE(F.IDTPIJURFORN, 'F', '1','2')||
                          LPAD(REPLACE(REPLACE(REPLACE(N.NRINSJURNF,'.',''),'/',''),'-',''),14,'0')|| /* campo 13 */
                          REPLACE(REPLACE(REPLACE(LPAD(NVL(NRINSMUNFORN, '0'), 15,'0'),'/',''),'-',''),'.','')|| /* inscricao municipal do tomador (fornecedor) campo 14 */
                          LPAD(NVL(REPLACE(REPLACE(REPLACE(NRINSESTFORN,'/',''),'.',''),'-',''), '0'), 15,'0')|| /* inscricao estadual do tomador */
                          UPPER(RPAD(NVL(SUBSTR(NMRAZSOCFORN, 1,115), ' '), 115,' '))|| /* campo 16 */
                          LPAD(' ', 3,' ')|| /* tipo de endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSENDEFORN, 1,100), ' '), 100,' '))|| /* DESCRIO DO ENDEREO*/
                          LPAD(' ', 10,' ')|| /* numero do endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSCOMPENDFOR, 1,60), ' '), 60,' '))|| /* CAMPO DE COMPLEMENTO DO ENDEREO */
                          UPPER(RPAD(NVL(SUBSTR(NMBAIRFORN, 1,72), ' '), 72,' '))|| /* BAIRRO DO TOMADOR */
                          UPPER(RPAD(NVL(SUBSTR(M.NMMUNICIPIO,1,50), ' '), 50,' '))|| /* cidade do tomador */
                          RPAD(NVL(E.SGESTADO, ' '), 2,' ')||  /* uf do tomador */
                          LPAD(NVL(SUBSTR(REPLACE(REPLACE(NRCEPFORN,'.',''),'-',''),1,8), '0'), 8,'0')|| /*CEP DO ENDEREO DO TOMADOR*/
                          UPPER(RPAD(NVL(DSEMAILFORN, ' '), 80,' '))|| /* CAMPO DE EMAIL DO TOMADOR */
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  || /* CAMPO 26*/
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  || /* CAMPO 27*/
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  || /* CAMPO 28*/
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  || /* CAMPO 29*/
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) || /* CAMPO 30*/
                          UPPER(RPAD(NVL(SUBSTR(DSPRODEMIS,1,1000), ' '), 100,' ')) AS DSFINAL

                   FROM NOTAFISCAL N, FORNECEDOR F, ENDEFORN E,
                        MUNICIPIO M, LISTA L, EMPRESA EP, IMPOSTO IT,
                        MUNICIPIO MU, ITEMPRODUTO IP, IMPOSTONF IF,
                        INSCRMUNICIP IM, INSCRESTAD IE
                   WHERE IDTPENDEFORN = 'P'
                     AND N.IDORIGDESTNF = 'F'
                     AND L.NRLISTA = P_NRLISTA
                     AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                     AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                     AND N.CDFORNECED = F.CDFORNECED
                     AND N.CDFILIAL = IP.CDFILIAL
                     AND N.NRLANCTONF = IP.NRLANCTONF
                     AND F.CDFORNECED = E.CDFORNECED
                     AND E.CDPAIS = M.CDPAIS
                     AND E.SGESTADO = M.SGESTADO
                     AND E.CDMUNICIPIO = M.CDMUNICIPIO
                     AND EP.CDEMPRESA = N.CDEMPRESA
                     AND EP.CDPAIS = MU.CDPAIS
                     AND EP.SGESTADO = MU.SGESTADO
                     AND EP.CDMUNICIPIO = MU.CDMUNICIPIO
                     AND N.CDEMPRESA = IM.CDEMPRESA
                     AND N.CDINSCMUNI = IM.CDINSCMUNI
                     AND N.CDEMPRESA = IE.CDEMPRESA
                     AND N.CDINSCESTA = IE.CDINSCESTA
                     AND IF.CDIMPOSTO   = V_ISS_NRET
                     AND IF.NRLANCTONF  = N.NRLANCTONF
                     AND IF.CDFILIAL    = N.CDFILIAL
                     AND IT.CDIMPOSTO   = V_ISS_NRET

                   /* CLIENTE ISS RETIDO*/
                   UNION ALL
                   SELECT N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'C' ),0)      AS VRTOTISS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'C' ),0) AS VRTOTISS_NRET,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0)   AS VRTOTCOFINS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0)     AS VRTOTCSLL,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0)     AS VRTOTINSS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0)     AS VRTOTIRPJ,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0)      AS VRTOTPIS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'I' ),0)      AS VRTOTCRED,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'I' ),0) AS VRTOTCRED_2,
                          '2'||
                          V_VRRPS||
                          RPAD(NVL(DECODE(N.IDENTRSAIDOP, 'S', N.CDSERIE, N.CDSERIEENTR),' '), 5, ' ')|| /* campo 3 */
                          LPAD(NVL(NRNOTAFISC,'0'), 15, '0')|| /* numero do rps */
                          TO_CHAR(DTEMISSAO, 'yyyymmdd')|| /* data de emissao do rps */
                          DECODE(IDSTATUS, 'C', 'C', 'T')|| /* situacao do rps  */
                          RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '0000000000000.00')), '.', ''),'0'),15,'0') AS DSINICIO,

                          '00017051'|| /* codigo do servico prestado na nf */
                          LPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'A' ),2), '00.00')), '.', ''),'0'),5,'0')|| /* valor da aliquota */
                          '1'|| /* ISS RETIDO  campo 11 */ /* iss retido */
                          DECODE(C.IDTPIJURCLIE, 'F', '1','2')||
                          LPAD(REPLACE(REPLACE(REPLACE(N.NRINSJURNF,'.',''),'/',''),'-',''),14,'0')||
                          LPAD(NVL('0', '0'), 15,'0')|| /* inscricao municipal do tomador (cliente) */
                          LPAD(NVL(REPLACE(REPLACE(REPLACE(NRINSESTCLIE,'/',''),'.',''),'-',''), '0'), 15,'0')|| /* inscricao estadual do tomador */
                          UPPER(RPAD(NVL(SUBSTR(NMRAZSOCCLIE, 1,115), ' '), 115,' '))||
                          LPAD(' ', 3,' ')|| /* tipo de endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSENDECLIE, 1,100), ' '), 100,' '))||
                          RPAD(' ', 10,' ')|| /* numero do endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSCOMPENDCLI, 1,60), ' '), 60,' '))||
                          UPPER(RPAD(NVL(SUBSTR(NMBAIRCLIE, 1,72), ' '), 72,' '))||
                          UPPER(RPAD(NVL(SUBSTR(M.NMMUNICIPIO,1,50), ' '), 50,' '))|| /* cidade do tomador */
                          RPAD(NVL(E.SGESTADO, ' '), 2,' ')||  /* uf do tomador */
                          LPAD(NVL(SUBSTR(REPLACE(REPLACE(NRCEPCLIE,'.',''),'-',''),1,8), '0'), 8,'0')||
                          UPPER(RPAD(NVL(DSEMAILCLIE, ' '), 80,' '))||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          UPPER(RPAD(NVL(SUBSTR(DSPRODEMIS,1,1000), ' '), 100,' ')) AS DSFINAL
                   FROM NOTAFISCAL N, CLIENTE C, ENDECLIE E,
                        MUNICIPIO M, LISTA L, EMPRESA EP, IMPOSTO IT,
                        MUNICIPIO MU, ITEMPRODUTO IP, IMPOSTONF IF,
                        INSCRMUNICIP IM, INSCRESTAD IE
                   WHERE IDTPENDECLIE = 'P'
                     AND N.IDORIGDESTNF = 'C'
                     AND L.NRLISTA = P_NRLISTA
                     AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                     AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                     AND N.CDCLIENTE = C.CDCLIENTE
                     AND N.CDFILIAL = IP.CDFILIAL
                     AND N.NRLANCTONF = IP.NRLANCTONF
                     AND C.CDCLIENTE = E.CDCLIENTE
                     AND E.CDPAIS = M.CDPAIS
                     AND E.SGESTADO = M.SGESTADO
                     AND E.CDMUNICIPIO = M.CDMUNICIPIO
                     AND EP.CDEMPRESA = N.CDEMPRESA
                     AND EP.CDPAIS = MU.CDPAIS
                     AND EP.SGESTADO = MU.SGESTADO
                     AND EP.CDMUNICIPIO = MU.CDMUNICIPIO
                     AND N.CDEMPRESA = IM.CDEMPRESA
                     AND N.CDINSCMUNI = IM.CDINSCMUNI
                     AND N.CDEMPRESA = IE.CDEMPRESA
                     AND N.CDINSCESTA = IE.CDINSCESTA
                     AND IF.CDIMPOSTO   = V_ISS
                     AND IF.NRLANCTONF  = N.NRLANCTONF
                     AND IF.CDFILIAL    = N.CDFILIAL
                     AND IT.CDIMPOSTO   = V_ISS

                   /* CLIENTE ISS NO RETIDO*/
                   UNION ALL
                   SELECT N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'C' ),0)      AS VRTOTISS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'C' ),0) AS VRTOTISS_NRET,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0)   AS VRTOTCOFINS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0)     AS VRTOTCSLL,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0)     AS VRTOTINSS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0)     AS VRTOTIRPJ,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0)      AS VRTOTPIS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'I' ),0)      AS VRTOTCRED,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'I' ),0) AS VRTOTCRED_2,
                          '2'||
                          V_VRRPS||
                          RPAD(NVL(DECODE(N.IDENTRSAIDOP, 'S', N.CDSERIE, N.CDSERIEENTR),' '), 5, ' ')|| /* campo 3 */
                          LPAD(NVL(NRNOTAFISC,'0'), 15, '0')|| /* numero do rps */
                          TO_CHAR(DTEMISSAO, 'yyyymmdd')|| /* data de emissao do rps */
                          DECODE(IDSTATUS, 'C', 'C', 'T')|| /* situacao do rps  */
                          RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '0000000000000.00')), '.', ''),'0'),15,'0') AS DSINICIO,

                          '00017051'|| /* codigo do servico prestado na nf */
                          LPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'A' ),2), '00.00')), '.', ''),'0'),5,'0')|| /* valor da aliquota */
                          '0'|| /* ISS NO RETIDO  campo 11 */ /* iss retido */
                          DECODE(C.IDTPIJURCLIE, 'F', '1','2')||
                          LPAD(REPLACE(REPLACE(REPLACE(N.NRINSJURNF,'.',''),'/',''),'-',''),14,'0')||
                          LPAD(NVL('0', '0'), 15,'0')|| /* inscricao municipal do tomador (cliente) */
                          LPAD(NVL(REPLACE(REPLACE(REPLACE(NRINSESTCLIE,'/',''),'.',''),'-',''), '0'), 15,'0')|| /* inscricao estadual do tomador */
                          UPPER(RPAD(NVL(SUBSTR(NMRAZSOCCLIE, 1,115), ' '), 115,' '))||
                          LPAD(' ', 3,' ')|| /* tipo de endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSENDECLIE, 1,100), ' '), 100,' '))||
                          RPAD(' ', 10,' ')|| /* numero do endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSCOMPENDCLI, 1,60), ' '), 60,' '))||
                          UPPER(RPAD(NVL(SUBSTR(NMBAIRCLIE, 1,72), ' '), 72,' '))||
                          UPPER(RPAD(NVL(SUBSTR(M.NMMUNICIPIO,1,50), ' '), 50,' '))|| /* cidade do tomador */
                          RPAD(NVL(E.SGESTADO, ' '), 2,' ')||  /* uf do tomador */
                          LPAD(NVL(SUBSTR(REPLACE(REPLACE(NRCEPCLIE,'.',''),'-',''),1,8), '0'), 8,'0')||
                          UPPER(RPAD(NVL(DSEMAILCLIE, ' '), 80,' '))||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          UPPER(RPAD(NVL(SUBSTR(DSPRODEMIS,1,1000), ' '), 100,' ')) AS DSFINAL
                   FROM NOTAFISCAL N, CLIENTE C, ENDECLIE E,
                        MUNICIPIO M, LISTA L, EMPRESA EP, IMPOSTO IT,
                        MUNICIPIO MU, ITEMPRODUTO IP, IMPOSTONF IF,
                        INSCRMUNICIP IM, INSCRESTAD IE
                   WHERE IDTPENDECLIE = 'P'
                     AND N.IDORIGDESTNF = 'C'
                     AND L.NRLISTA = P_NRLISTA
                     AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                     AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                     AND N.CDCLIENTE = C.CDCLIENTE
                     AND N.CDFILIAL = IP.CDFILIAL
                     AND N.NRLANCTONF = IP.NRLANCTONF
                     AND C.CDCLIENTE = E.CDCLIENTE
                     AND E.CDPAIS = M.CDPAIS
                     AND E.SGESTADO = M.SGESTADO
                     AND E.CDMUNICIPIO = M.CDMUNICIPIO
                     AND EP.CDEMPRESA = N.CDEMPRESA
                     AND EP.CDPAIS = MU.CDPAIS
                     AND EP.SGESTADO = MU.SGESTADO
                     AND EP.CDMUNICIPIO = MU.CDMUNICIPIO
                     AND N.CDEMPRESA = IM.CDEMPRESA
                     AND N.CDINSCMUNI = IM.CDINSCMUNI
                     AND N.CDEMPRESA = IE.CDEMPRESA
                     AND N.CDINSCESTA = IE.CDINSCESTA
                     AND IF.CDIMPOSTO   = V_ISS_NRET
                     AND IF.NRLANCTONF  = N.NRLANCTONF
                     AND IF.CDFILIAL    = N.CDFILIAL
                     AND IT.CDIMPOSTO   = V_ISS_NRET

                   /* FILIAL entrada ISS RETIDO */
                   UNION ALL
                   SELECT N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'C' ),0)      AS VRTOTISS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'C' ),0) AS VRTOTISS_NRET,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0)   AS VRTOTCOFINS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0)     AS VRTOTCSLL,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0)     AS VRTOTINSS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0)     AS VRTOTIRPJ,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0)      AS VRTOTPIS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'I' ),0)      AS VRTOTCRED,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'I' ),0) AS VRTOTCRED_2,
                          '2'||
                          V_VRRPS||
                          RPAD(NVL(DECODE(N.IDENTRSAIDOP, 'S', N.CDSERIE, N.CDSERIEENTR),' '), 5, ' ')|| /* campo 6 */
                          LPAD(NVL(NRNOTAFISC,'0'), 15, '0')|| /* numero do rps */
                          TO_CHAR(DTEMISSAO, 'yyyymmdd')|| /* data de emissao do rps */
                          DECODE(IDSTATUS, 'C', 'C', 'T')||
                          RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '0000000000000.00')), '.', ''),'0'),15,'0') AS DSINICIO,

                          '00017051'|| /* codigo do servico prestado na nf */
                          LPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'A' ),2), '00.00')), '.', ''),'0'),5,'0')|| /* valor da aliquota */
                          '1'|| /* ISS RETIDO  campo 11 */
                          DECODE(F.IDTPIJURFILI, 'F', '1','2')||
                          LPAD(REPLACE(REPLACE(REPLACE(N.NRINSJURNF,'.',''),'/',''),'-',''),14,'0')||
                          LPAD(NVL('0', '0'), 15,'0')|| /* inscricao municipal do tomador (cliente) */
                          LPAD(NVL(REPLACE(REPLACE(REPLACE(F.CDINSCESTA,'/',''),'.',''),'-',''), '0'), 15,'0')|| /* inscricao estadual do tomador */
                          UPPER(RPAD(NVL(SUBSTR(NMRAZSOCFILI, 1,115), ' '), 115,' '))||
                          LPAD(' ', 3,' ')|| /* tipo de endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSENDEFILI, 1,100), ' '), 100,' '))||
                          LPAD(' ', 10,' ')|| /* numero do endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSCOMPENDFIL, 1,60), ' '), 60,' '))||
                          UPPER(RPAD(NVL(SUBSTR(NMBAIRFILI, 1,72), ' '), 72,' '))||
                          UPPER(RPAD(NVL(SUBSTR(M.NMMUNICIPIO,1,50), ' '), 50,' '))|| /* cidade do tomador */
                          RPAD(NVL(E.SGESTADO, ' '), 2,' ')||  /* uf do tomador */
                          LPAD(NVL(SUBSTR(REPLACE(REPLACE(NRCEPFILI,'.',''),'-',''),1,8), '0'), 8,'0')||
                          UPPER(RPAD(NVL(DSEMAILFILI, ' '), 80,' '))||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          UPPER(RPAD(NVL(SUBSTR(DSPRODEMIS,1,1000), ' '), 10,' ')) AS DSFINAL
                   FROM NOTAFISCAL N, FILIAL F, ENDEFILI E,
                        MUNICIPIO M, LISTA L, EMPRESA EP, IMPOSTO IT,
                        MUNICIPIO MU, ITEMPRODUTO IP, IMPOSTONF IF,
                        INSCRMUNICIP IM, INSCRESTAD IE
                   WHERE L.NRLISTA = P_NRLISTA
                     AND N.IDENTRSAIDOP = 'E'
                     AND IDTPENDEFILI = 'P'
                     AND N.IDORIGDESTNF = 'L'
                     AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                     AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                     AND N.CDFILIRECE = F.CDFILIAL
                     AND N.CDFILIAL = IP.CDFILIAL
                     AND N.NRLANCTONF = IP.NRLANCTONF
                     AND F.CDFILIAL = E.CDFILIAL
                     AND E.CDPAIS = M.CDPAIS
                     AND E.SGESTADO = M.SGESTADO
                     AND E.CDMUNICIPIO = M.CDMUNICIPIO
                     AND EP.CDEMPRESA = N.CDEMPRESA
                     AND EP.CDPAIS = MU.CDPAIS
                     AND EP.SGESTADO = MU.SGESTADO
                     AND EP.CDMUNICIPIO = MU.CDMUNICIPIO
                     AND N.CDEMPRESA = IM.CDEMPRESA
                     AND N.CDINSCMUNI = IM.CDINSCMUNI
                     AND N.CDEMPRESA = IE.CDEMPRESA
                     AND N.CDINSCESTA = IE.CDINSCESTA
                     AND IF.CDIMPOSTO   = V_ISS
                     AND IF.NRLANCTONF  = N.NRLANCTONF
                     AND IF.CDFILIAL    = N.CDFILIAL
                     AND IT.CDIMPOSTO   = V_ISS

                   /* FILIAL entrada ISS NO RETIDO */
                   UNION ALL
                   SELECT N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'C' ),0)      AS VRTOTISS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'C' ),0) AS VRTOTISS_NRET,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0)   AS VRTOTCOFINS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0)     AS VRTOTCSLL,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0)     AS VRTOTINSS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0)     AS VRTOTIRPJ,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0)      AS VRTOTPIS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'I' ),0)      AS VRTOTCRED,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'I' ),0) AS VRTOTCRED_2,
                          '2'||
                          V_VRRPS||
                          RPAD(NVL(DECODE(N.IDENTRSAIDOP, 'S', N.CDSERIE, N.CDSERIEENTR),' '), 5, ' ')|| /* campo 6 */
                          LPAD(NVL(NRNOTAFISC,'0'), 15, '0')|| /* numero do rps */
                          TO_CHAR(DTEMISSAO, 'yyyymmdd')|| /* data de emissao do rps */
                          DECODE(IDSTATUS, 'C', 'C', 'T')||
                          RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '0000000000000.00')), '.', ''),'0'),15,'0') AS DSINICIO,

                          '00017051'|| /* codigo do servico prestado na nf */
                          LPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'A' ),2), '00.00')), '.', ''),'0'),5,'0')|| /* valor da aliquota */
                          '0'|| /* ISS NO RETIDO  campo 11 */
                          DECODE(F.IDTPIJURFILI, 'F', '1','2')||
                          LPAD(REPLACE(REPLACE(REPLACE(N.NRINSJURNF,'.',''),'/',''),'-',''),14,'0')||
                          LPAD(NVL('0', '0'), 15,'0')|| /* inscricao municipal do tomador (cliente) */
                          LPAD(NVL(REPLACE(REPLACE(REPLACE(F.CDINSCESTA,'/',''),'.',''),'-',''), '0'), 15,'0')|| /* inscricao estadual do tomador */
                          UPPER(RPAD(NVL(SUBSTR(NMRAZSOCFILI, 1,115), ' '), 115,' '))||
                          LPAD(' ', 3,' ')|| /* tipo de endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSENDEFILI, 1,100), ' '), 100,' '))||
                          LPAD(' ', 10,' ')|| /* numero do endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSCOMPENDFIL, 1,60), ' '), 60,' '))||
                          UPPER(RPAD(NVL(SUBSTR(NMBAIRFILI, 1,72), ' '), 72,' '))||
                          UPPER(RPAD(NVL(SUBSTR(M.NMMUNICIPIO,1,50), ' '), 50,' '))|| /* cidade do tomador */
                          RPAD(NVL(E.SGESTADO, ' '), 2,' ')||  /* uf do tomador */
                          LPAD(NVL(SUBSTR(REPLACE(REPLACE(NRCEPFILI,'.',''),'-',''),1,8), '0'), 8,'0')||
                          UPPER(RPAD(NVL(DSEMAILFILI, ' '), 80,' '))||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          UPPER(RPAD(NVL(SUBSTR(DSPRODEMIS,1,1000), ' '), 10,' ')) AS DSFINAL
                   FROM NOTAFISCAL N, FILIAL F, ENDEFILI E,
                        MUNICIPIO M, LISTA L, EMPRESA EP, IMPOSTO IT,
                        MUNICIPIO MU, ITEMPRODUTO IP, IMPOSTONF IF,
                        INSCRMUNICIP IM, INSCRESTAD IE
                   WHERE L.NRLISTA = P_NRLISTA
                     AND N.IDENTRSAIDOP = 'E'
                     AND IDTPENDEFILI = 'P'
                     AND N.IDORIGDESTNF = 'L'
                     AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                     AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                     AND N.CDFILIRECE = F.CDFILIAL
                     AND N.CDFILIAL = IP.CDFILIAL
                     AND N.NRLANCTONF = IP.NRLANCTONF
                     AND F.CDFILIAL = E.CDFILIAL
                     AND E.CDPAIS = M.CDPAIS
                     AND E.SGESTADO = M.SGESTADO
                     AND E.CDMUNICIPIO = M.CDMUNICIPIO
                     AND EP.CDEMPRESA = N.CDEMPRESA
                     AND EP.CDPAIS = MU.CDPAIS
                     AND EP.SGESTADO = MU.SGESTADO
                     AND EP.CDMUNICIPIO = MU.CDMUNICIPIO
                     AND N.CDEMPRESA = IM.CDEMPRESA
                     AND N.CDINSCMUNI = IM.CDINSCMUNI
                     AND N.CDEMPRESA = IE.CDEMPRESA
                     AND N.CDINSCESTA = IE.CDINSCESTA
                     AND IF.CDIMPOSTO   = V_ISS_NRET
                     AND IF.NRLANCTONF  = N.NRLANCTONF
                     AND IF.CDFILIAL    = N.CDFILIAL
                     AND IT.CDIMPOSTO   = V_ISS_NRET


                   /* FILIAL sada ISS RETIDO */
                   UNION ALL
                   SELECT N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'C' ),0)      AS VRTOTISS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'C' ),0) AS VRTOTISS_NRET,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0)   AS VRTOTCOFINS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0)     AS VRTOTCSLL,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0)     AS VRTOTINSS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0)     AS VRTOTIRPJ,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0)      AS VRTOTPIS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'I' ),0)      AS VRTOTCRED,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'I' ),0) AS VRTOTCRED_2,
                          '2'||
                          V_VRRPS||
                          RPAD(NVL(DECODE(N.IDENTRSAIDOP, 'S', N.CDSERIE, N.CDSERIEENTR),' '), 5, ' ')|| /* campo 6 */
                          LPAD(NVL(NRNOTAFISC,'0'), 15, '0')|| /* numero do rps */
                          TO_CHAR(DTEMISSAO, 'yyyymmdd')|| /* data de emissao do rps */
                          DECODE(IDSTATUS, 'C', 'C', 'T')||
                          RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '0000000000000.00')), '.', ''),'0'),15,'0') AS DSINICIO,

                          '00017051'|| /* codigo do servico prestado na nf */
                          LPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'A' ),2), '00.00')), '.', ''),'0'),5,'0')|| /* valor da aliquota */
                          '1'|| /* ISS RETIDO  campo 11 */
                          DECODE(F.IDTPIJURFILI, 'F', '1','2')||
                          LPAD(REPLACE(REPLACE(REPLACE(N.NRINSJURNF,'.',''),'/',''),'-',''),14,'0')||
                          LPAD(NVL('0', '0'), 15,'0')|| /* inscricao municipal do tomador (cliente) */
                          LPAD(NVL(REPLACE(REPLACE(REPLACE(F.CDINSCESTA,'/',''),'.',''),'-',''), '0'), 15,'0')|| /* inscricao estadual do tomador */
                          UPPER(RPAD(NVL(SUBSTR(NMRAZSOCFILI, 1,115), ' '), 115,' '))||
                          LPAD(' ', 3,' ')|| /* tipo de endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSENDEFILI, 1,100), ' '), 100,' '))||
                          LPAD(' ', 10,' ')|| /* numero do endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSCOMPENDFIL, 1,60), ' '), 60,' '))||
                          UPPER(RPAD(NVL(SUBSTR(NMBAIRFILI, 1,72), ' '), 72,' '))||
                          UPPER(RPAD(NVL(SUBSTR(M.NMMUNICIPIO,1,50), ' '), 50,' '))|| /* cidade do tomador */
                          RPAD(NVL(E.SGESTADO, ' '), 2,' ')||  /* uf do tomador */
                          LPAD(NVL(SUBSTR(REPLACE(REPLACE(NRCEPFILI,'.',''),'-',''),1,8), '0'), 8,'0')||
                          UPPER(RPAD(NVL(DSEMAILFILI, ' '), 80,' '))||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          UPPER(RPAD(NVL(SUBSTR(DSPRODEMIS,1,1000), ' '), 10,' ')) AS DSFINAL
                   FROM NOTAFISCAL N, FILIAL F, ENDEFILI E,
                        MUNICIPIO M, LISTA L, EMPRESA EP, IMPOSTO IT,
                        MUNICIPIO MU, ITEMPRODUTO IP, IMPOSTONF IF,
                        INSCRMUNICIP IM, INSCRESTAD IE
                   WHERE L.NRLISTA = P_NRLISTA
                     AND N.IDENTRSAIDOP = 'S'
                     AND IDTPENDEFILI = 'P'
                     AND N.IDORIGDESTNF = 'L'
                     AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                     AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                     AND N.CDFILIRECE = F.CDFILIAL
                     AND N.CDFILIAL = IP.CDFILIAL
                     AND N.NRLANCTONF = IP.NRLANCTONF
                     AND F.CDFILIAL = E.CDFILIAL
                     AND E.CDPAIS = M.CDPAIS
                     AND E.SGESTADO = M.SGESTADO
                     AND E.CDMUNICIPIO = M.CDMUNICIPIO
                     AND EP.CDEMPRESA = N.CDEMPRESA
                     AND EP.CDPAIS = MU.CDPAIS
                     AND EP.SGESTADO = MU.SGESTADO
                     AND EP.CDMUNICIPIO = MU.CDMUNICIPIO
                     AND N.CDEMPRESA = IM.CDEMPRESA
                     AND N.CDINSCMUNI = IM.CDINSCMUNI
                     AND N.CDEMPRESA = IE.CDEMPRESA
                     AND N.CDINSCESTA = IE.CDINSCESTA
                     AND IF.CDIMPOSTO   = V_ISS
                     AND IF.NRLANCTONF  = N.NRLANCTONF
                     AND IF.CDFILIAL    = N.CDFILIAL
                     AND IT.CDIMPOSTO   = V_ISS

                   /* FILIAL sada ISS NO RETIDO */
                   UNION ALL
                   SELECT N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'C' ),0)      AS VRTOTISS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'C' ),0) AS VRTOTISS_NRET,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0)   AS VRTOTCOFINS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0)     AS VRTOTCSLL,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0)     AS VRTOTINSS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0)     AS VRTOTIRPJ,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0)      AS VRTOTPIS,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS, 'I' ),0)      AS VRTOTCRED,
                          NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'I' ),0) AS VRTOTCRED_2,
                          '2'||
                          V_VRRPS||
                          RPAD(NVL(DECODE(N.IDENTRSAIDOP, 'S', N.CDSERIE, N.CDSERIEENTR),' '), 5, ' ')|| /* campo 6 */
                          LPAD(NVL(NRNOTAFISC,'0'), 15, '0')|| /* numero do rps */
                          TO_CHAR(DTEMISSAO, 'yyyymmdd')|| /* data de emissao do rps */
                          DECODE(IDSTATUS, 'C', 'C', 'T')||
                          RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '0000000000000.00')), '.', ''),'0'),15,'0') AS DSINICIO,

                          '00017051'|| /* codigo do servico prestado na nf */
                          LPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_ISS_NRET, 'A' ),2), '00.00')), '.', ''),'0'),5,'0')|| /* valor da aliquota */
                          '0'|| /* ISS NO RETIDO  campo 11 */
                          DECODE(F.IDTPIJURFILI, 'F', '1','2')||
                          LPAD(REPLACE(REPLACE(REPLACE(N.NRINSJURNF,'.',''),'/',''),'-',''),14,'0')||
                          LPAD(NVL('0', '0'), 15,'0')|| /* inscricao municipal do tomador (cliente) */
                          LPAD(NVL(REPLACE(REPLACE(REPLACE(F.CDINSCESTA,'/',''),'.',''),'-',''), '0'), 15,'0')|| /* inscricao estadual do tomador */
                          UPPER(RPAD(NVL(SUBSTR(NMRAZSOCFILI, 1,115), ' '), 115,' '))||
                          LPAD(' ', 3,' ')|| /* tipo de endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSENDEFILI, 1,100), ' '), 100,' '))||
                          LPAD(' ', 10,' ')|| /* numero do endereco do tomador */
                          UPPER(RPAD(NVL(SUBSTR(DSCOMPENDFIL, 1,60), ' '), 60,' '))||
                          UPPER(RPAD(NVL(SUBSTR(NMBAIRFILI, 1,72), ' '), 72,' '))||
                          UPPER(RPAD(NVL(SUBSTR(M.NMMUNICIPIO,1,50), ' '), 50,' '))|| /* cidade do tomador */
                          RPAD(NVL(E.SGESTADO, ' '), 2,' ')||  /* uf do tomador */
                          LPAD(NVL(SUBSTR(REPLACE(REPLACE(NRCEPFILI,'.',''),'-',''),1,8), '0'), 8,'0')||
                          UPPER(RPAD(NVL(DSEMAILFILI, ' '), 80,' '))||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_COFINS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_CSLL, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_INSS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0) ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_IRPJ, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(VALOR_IMPOSTO_NF(N.CDFILIAL, N.NRLANCTONF, V_PIS, 'I' ),0),2),'9999999999990.00')),'.',''),15,0)  ||
                          UPPER(RPAD(NVL(SUBSTR(DSPRODEMIS,1,1000), ' '), 10,' ')) AS DSFINAL
                   FROM NOTAFISCAL N, FILIAL F, ENDEFILI E,
                        MUNICIPIO M, LISTA L, EMPRESA EP, IMPOSTO IT,
                        MUNICIPIO MU, ITEMPRODUTO IP, IMPOSTONF IF,
                        INSCRMUNICIP IM, INSCRESTAD IE
                   WHERE L.NRLISTA = P_NRLISTA
                     AND N.IDENTRSAIDOP = 'S'
                     AND IDTPENDEFILI = 'P'
                     AND N.IDORIGDESTNF = 'L'
                     AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                     AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                     AND N.CDFILIRECE = F.CDFILIAL
                     AND N.CDFILIAL = IP.CDFILIAL
                     AND N.NRLANCTONF = IP.NRLANCTONF
                     AND F.CDFILIAL = E.CDFILIAL
                     AND E.CDPAIS = M.CDPAIS
                     AND E.SGESTADO = M.SGESTADO
                     AND E.CDMUNICIPIO = M.CDMUNICIPIO
                     AND EP.CDEMPRESA = N.CDEMPRESA
                     AND EP.CDPAIS = MU.CDPAIS
                     AND EP.SGESTADO = MU.SGESTADO
                     AND EP.CDMUNICIPIO = MU.CDMUNICIPIO
                     AND N.CDEMPRESA = IM.CDEMPRESA
                     AND N.CDINSCMUNI = IM.CDINSCMUNI
                     AND N.CDEMPRESA = IE.CDEMPRESA
                     AND N.CDINSCESTA = IE.CDINSCESTA
                     AND IF.CDIMPOSTO   = V_ISS_NRET
                     AND IF.NRLANCTONF  = N.NRLANCTONF
                     AND IF.CDFILIAL    = N.CDFILIAL
                     AND IT.CDIMPOSTO   = V_ISS_NRET) LOOP

      SELECT SUM(VRITEMENCA)
      INTO V_VRDEDUCAO
      FROM ENCARGO E, ITEMENCARGO I
      WHERE E.CDENCARGO = I.CDENCARGO
        AND VRITEMENCA > 0
        AND IDENCARGO = 'D'
        AND CDFILIAL = C_NOTAS.CDFILIAL
        AND NRLANCTONF = C_NOTAS.NRLANCTONF;

      V_DADOS := C_NOTAS.DSINICIO||RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRDEDUCAO,2), '0000000000000.00')), '.', ''),'0'), 15, '0')||C_NOTAS.DSFINAL;
      V_VRTOTAL := NVL(V_VRTOTAL,0)+NVL(C_NOTAS.VRNOTAFISC,0);
      V_VRTOTDEDUCAO  := NVL(V_VRTOTDEDUCAO,0)+NVL(V_VRDEDUCAO,0);
      V_VRTOTISS      := NVL(V_VRTOTISS,0)+NVL(C_NOTAS.VRTOTISS,0);
      V_VRTOTISS_NRET := NVL(V_VRTOTISS_NRET,0)+NVL(C_NOTAS.VRTOTISS_NRET,0);
      V_VRTOTCOFINS   := NVL(V_VRTOTCOFINS,0)+NVL(C_NOTAS.VRTOTCOFINS,0);
      V_VRTOTCSLL     := NVL(V_VRTOTCSLL,0)+NVL(C_NOTAS.VRTOTCSLL,0);
      V_VRTOTINSS     := NVL(V_VRTOTINSS,0)+NVL(C_NOTAS.VRTOTINSS,0);
      V_VRTOTIRPJ     := NVL(V_VRTOTIRPJ,0)+NVL(C_NOTAS.VRTOTIRPJ,0);
      V_VRTOTPIS      := NVL(V_VRTOTPIS,0)+NVL(C_NOTAS.VRTOTPIS,0);
      V_VRTOTCRED     := NVL(V_VRTOTCRED,0)+NVL(C_NOTAS.VRTOTCRED,0);
      V_VRTOTCRED_2   := NVL(V_VRTOTCRED_2,0)+NVL(C_NOTAS.VRTOTCRED_2,0);

      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        (V_CONTADOR, V_DADOS, P_NRSEQARQMAG);
      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      V_CONT_REG_2 := NVL(V_CONT_REG_2,0)+1;
      /* identificador de exportao da nf */

      UPDATE NOTAFISCAL
      SET IDEXPNFEMANAUS = 'S'
      WHERE CDFILIAL = C_NOTAS.CDFILIAL
        AND NRLANCTONF = C_NOTAS.NRLANCTONF;
   END LOOP;

   V_DADOS_9 := '9'||
                LPAD(NVL(V_CONT_REG_2,0), 7, '0')||
                NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRTOTAL,2), '0000000000000.00')), '.', ''),'0')||
                NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRTOTDEDUCAO,2), '0000000000000.00')), '.', ''),'0')||
                NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRTOTCOFINS,2), '0000000000000.00')), '.', ''),'0')||
                NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRTOTCSLL,2), '0000000000000.00')), '.', ''),'0')||
                NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRTOTINSS,2), '0000000000000.00')), '.', ''),'0')||
                NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRTOTIRPJ,2), '0000000000000.00')), '.', ''),'0')||
                NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRTOTPIS,2), '0000000000000.00')), '.', ''),'0');


   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (V_CONTADOR, V_DADOS_9 , P_NRSEQARQMAG);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('NOTAFISCAL_NFE_MANAUS','5.07.011'); END;
/

